const { errors } = require('cozy-konnector-libs')
const index = require('../src')

const mockSoapRequest = jest.fn()
jest.mock('easy-soap-request', () => async () => mockSoapRequest())

const responseMock = {
  response: {
    body: 'mockedBody',
  },
}

/** Theses tests are not working
 * the function getContractStartDate needs to be in a seperate file
 * OR the konnector.start needs to be mocked ?
 */
describe('getContractStartDate', () => {
  it('should return void when successfully got contract start date ✅', async () => {
    mockSoapRequest.mockResolvedValue(responseMock)
    expect.assertions(1)
    try {
      await index.getContractStartDate()
      expect(true).toBeTruthy()
    } catch (error) {
      expect(true).toBe(false)
    }
  })

  it('should throw VENDOR_DOWN when failing request 🚫', async () => {
    mockSoapRequest.mockRejectedValueOnce('error')

    try {
      await index.getContractStartDate()
      expect(true).toBe(false)
    } catch (error) {
      expect(error).toBe(errors.VENDOR_DOWN)
    }
  })

  it('should throw NOT_EXISTING_DIRECTORY when failing parsing 🚫', async () => {
    //mock processStartDate
    // processStartDate.mockRejectedValueOnce('error')
    try {
      await index.getContractStartDate()
      expect(true).toBe(false)
    } catch (error) {
      expect(error).toBe(errors.NOT_EXISTING_DIRECTORY)
    }
  })
})
